\section{Conclusion}
\label{sec:conclusion}

In this work we have walked the first steps when using OpenCL. We have seen
that even naive parallel implementations can outperform optimized single
threaded implementations when the work size is high enough. 

We have discovered that device configuration is important and there is
optimization room when tunning how the hardware is used. However, OpenCL does a
fair job with an out of the box hardware configuration. By the other hand, the
performance gain from optimized algorithms are very significant. Naive
implementations don't take full advantage of the device capabilities. We
advocate that it is better to research and use first state-of-the-art parallel
implementations for common problems.

As a final remark, this work has taught as that profiling and benchmarking
tools are essential for programming in OpenCL. There are many pitfalls and
hardware details that could ruin the performance. If one decides to use OpenCL
is because performance is important enough to justify the added complexity, one
should try to improve an existing single threaded implementation without
developing a benchmark that proves the performance gain.